Coin: SoTransformerDragger Class Reference

| Coin3D is Free Software, published under the BSD 3-clause license. | https://coin3d.github.io https://www.kongsberg.com/en/kogt/

SoTransformerDragger Class Reference
Dragger Classes

The SoTransformerDragger provides geometry for translation, scaling and rotations. More...

`#include <Inventor/draggers/SoTransformerDragger.h>`

Inheritance diagram for SoTransformerDragger:

## Public Types
enum | State { INACTIVE , RIT_X_ROTATE , TOP_Y_ROTATE , FNT_Z_ROTATE , LFT_X_ROTATE , BOT_Y_ROTATE , BAK_Z_ROTATE , PX_PY_PZ_3D_SCALE , PX_PY_NZ_3D_SCALE , PX_NY_PZ_3D_SCALE , PX_NY_NZ_3D_SCALE , NX_PY_PZ_3D_SCALE , NX_PY_NZ_3D_SCALE , NX_NY_PZ_3D_SCALE , NX_NY_NZ_3D_SCALE , RIT_TRANSLATE , TOP_TRANSLATE , FNT_TRANSLATE , LFT_TRANSLATE , BOT_TRANSLATE , BAK_TRANSLATE }
Public Types inherited from SoDragger
enum | ProjectorFrontSetting { FRONT , BACK , USE_PICK }
Public Types inherited from SoInteractionKit
enum | CacheEnabled { OFF , ON , AUTO }
Public Types inherited from SoNode
enum | NodeType { INVENTOR = 0x0000 , VRML1 = 0x0001 , VRML2 = 0x0002 , INVENTOR_1 = 0x0004 , INVENTOR_2_0 = 0x0008 , INVENTOR_2_1 = 0x0010 , INVENTOR_2_5 = 0x0020 , INVENTOR_2_6 = 0x0040 , COIN_1_0 = 0x0080 , COIN_2_0 = 0x0100 , EXTENSION = 0x0200 , COIN_2_2 = 0x0400 , COIN_2_3 = 0x0800 , COIN_2_4 = 0x1000 , INVENTOR_5_0 = 0x2000 , COIN_2_5 = 0x4000 , COIN_3_0 = 0x8000 , INVENTOR_6_0 = 0x10000 , COIN_4_0 = 0x20000 }

## Public Member Functions
virtual SoType | getTypeId (void) const
virtual const SoNodekitCatalog * | getNodekitCatalog (void) const
| SoTransformerDragger (void)
State | getCurrentState (void)
void | unsquishKnobs (void)
SbBool | isLocateHighlighting (void)
void | setLocateHighlighting (SbBool onoff)
SbVec3f | getBoxPointInWorldSpace (const SbVec3f &pointonunitbox)
SbVec3f | getBoxDirInWorldSpace (const SbVec3f &dironunitbox)
SbVec3f | getWorldPointInBoxSpace (const SbVec3f &pointinworldspace)
SbVec2f | getWorldPointInPixelSpace (const SbVec3f &thepoint)
SbVec3f | getInteractiveCenterInBoxSpace (void)
Public Member Functions inherited from SoDragger
virtual void | callback (SoCallbackAction *action)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | getMatrix (SoGetMatrixAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | search (SoSearchAction *action)
virtual void | write (SoWriteAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
void | setProjectorEpsilon (const float epsilon)
float | getProjectorEpsilon (void) const
void | addStartCallback (SoDraggerCB *func, void *data=NULL)
void | removeStartCallback (SoDraggerCB *func, void *data=NULL)
void | addMotionCallback (SoDraggerCB *func, void *data=NULL)
void | removeMotionCallback (SoDraggerCB *func, void *data=NULL)
void | addFinishCallback (SoDraggerCB *func, void *data=NULL)
void | removeFinishCallback (SoDraggerCB *func, void *data=NULL)
void | addValueChangedCallback (SoDraggerCB *func, void *data=NULL)
void | removeValueChangedCallback (SoDraggerCB *func, void *data=NULL)
void | setMinGesture (int pixels)
int | getMinGesture (void) const
SbBool | enableValueChangedCallbacks (SbBool newval)
const SbMatrix & | getMotionMatrix (void)
void | addOtherEventCallback (SoDraggerCB *func, void *data=NULL)
void | removeOtherEventCallback (SoDraggerCB *func, void *data=NULL)
void | registerChildDragger (SoDragger *child)
void | unregisterChildDragger (SoDragger *child)
void | registerChildDraggerMovingIndependently (SoDragger *child)
void | unregisterChildDraggerMovingIndependently (SoDragger *child)
SbMatrix | getLocalToWorldMatrix (void)
SbMatrix | getWorldToLocalMatrix (void)
SbVec3f | getLocalStartingPoint (void)
SbVec3f | getWorldStartingPoint (void)
void | getPartToLocalMatrix (const SbName &partname, SbMatrix &parttolocalmatrix, SbMatrix &localtopartmatrix)
void | transformMatrixLocalToWorld (const SbMatrix &frommatrix, SbMatrix &tomatrix)
void | transformMatrixWorldToLocal (const SbMatrix &frommatrix, SbMatrix &tomatrix)
void | transformMatrixToLocalSpace (const SbMatrix &frommatrix, SbMatrix &tomatrix, const SbName &fromspacepartname)
virtual void | setMotionMatrix (const SbMatrix &newmatrix)
void | valueChanged (void)
const SbMatrix & | getStartMotionMatrix (void)
virtual void | saveStartParameters (void)
const SoPath * | getPickPath (void) const
const SoEvent * | getEvent (void) const
SoPath * | createPathToThis (void)
const SoPath * | getSurrogatePartPickedOwner (void) const
const SbName & | getSurrogatePartPickedName (void) const
const SoPath * | getSurrogatePartPickedPath (void) const
void | setStartingPoint (const SoPickedPoint *newpoint)
void | setStartingPoint (const SbVec3f &newpoint)
const SbViewVolume & | getViewVolume (void)
void | setViewVolume (const SbViewVolume &vol)
const SbViewportRegion & | getViewportRegion (void)
void | setViewportRegion (const SbViewportRegion &reg)
SoHandleEventAction * | getHandleEventAction (void) const
void | setHandleEventAction (SoHandleEventAction *newAction)
void | setTempPathToThis (const SoPath *somethingclose)
virtual void | grabEventsSetup (void)
virtual void | grabEventsCleanup (void)
void | workFieldsIntoTransform (SbMatrix &mtx)
void | setFrontOnProjector (ProjectorFrontSetting newval)
ProjectorFrontSetting | getFrontOnProjector (void) const
Public Member Functions inherited from SoInteractionKit
| SoInteractionKit (void)
virtual SbBool | setPartAsPath (const SbName &partname, SoPath *path)
virtual SbBool | setPartAsDefault (const SbName &partname, SoNode *node, SbBool onlyifdefault=TRUE)
virtual SbBool | setPartAsDefault (const SbName &partname, const SbName &nodename, SbBool onlyifdefault=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path, SoPath *&pathToOwner, SbName &surrogatename, SoPath *&surrogatepath, SbBool fillargs=TRUE)
SbBool | isPathSurrogateInMySubgraph (const SoPath *path)
virtual SbBool | setPart (const SbName &partname, SoNode *from)
Public Member Functions inherited from SoBaseKit
| SoBaseKit (void)
virtual SoNode * | getPart (const SbName &partname, SbBool makeifneeded)
SbString | getPartString (const SoBase *part)
virtual SoNodeKitPath * | createPathToPart (const SbName &partname, SbBool makeifneeded, const SoPath *pathtoextend=NULL)
SbBool | set (const char *namevaluepairliststring)
SbBool | set (const char *partnamestring, const char *parameterstring)
virtual void | doAction (SoAction *action)
virtual SoChildList * | getChildren (void) const
void | printDiagram (void)
void | printSubDiagram (const SbName &rootname, int level)
void | printTable (void)
virtual void | addWriteReference (SoOutput *out, SbBool isfromfield=FALSE)
SbBool | forceChildDrivenWriteRefs (SoOutput *out)
Public Member Functions inherited from SoNode
void | setOverride (const SbBool state)
SbBool | isOverride (void) const
void | setNodeType (const NodeType type)
NodeType | getNodeType (void) const
virtual SoNode * | copy (SbBool copyconnections=FALSE) const
virtual SbBool | affectsState (void) const
virtual void | GLRenderBelowPath (SoGLRenderAction *action)
virtual void | GLRenderInPath (SoGLRenderAction *action)
virtual void | GLRenderOffPath (SoGLRenderAction *action)
virtual void | pick (SoPickAction *action)
virtual void | audioRender (SoAudioRenderAction *action)
virtual void | startNotify (void)
virtual void | notify (SoNotList *l)
SbUniqueId | getNodeId (void) const
virtual void | writeInstance (SoOutput *out)
virtual SoFieldContainer * | copyThroughConnection (void) const
Public Member Functions inherited from SoFieldContainer
void | setToDefaults (void)
SbBool | hasDefaultValues (void) const
SbBool | fieldsAreEqual (const SoFieldContainer *container) const
void | copyFieldValues (const SoFieldContainer *container, SbBool copyconnections=FALSE)
SbBool | set (const char *const fielddata)
void | get (SbString &fielddata)
virtual int | getFields (SoFieldList &l) const
virtual int | getAllFields (SoFieldList &l) const
virtual SoField * | getField (const SbName &name) const
virtual SoField * | getEventIn (const SbName &name) const
virtual SoField * | getEventOut (const SbName &name) const
SbBool | getFieldName (const SoField *const field, SbName &name) const
SbBool | enableNotify (const SbBool flag)
SbBool | isNotifyEnabled (void) const
SbBool | set (const char *fielddata, SoInput *input)
void | get (SbString &fielddata, SoOutput *out)
virtual SbBool | validateNewFieldValue (SoField *field, void *newval)
SbBool | getIsBuiltIn (void) const
virtual void | getFieldsMemorySize (size_t &managed, size_t &unmanaged) const
void | setUserData (void *userdata) const
void * | getUserData (void) const
Public Member Functions inherited from SoBase
void | ref (void) const
void | unref (void) const
void | unrefNoDelete (void) const
int32_t | getRefCount (void) const
void | touch (void)
SbBool | isOfType (SoType type) const
| Returns `TRUE` if the type of this object is either of the same type or inherited from type.
virtual SbName | getName (void) const
virtual void | setName (const SbName &newname)
void | addAuditor (void *const auditor, const SoNotRec::Type type)
void | removeAuditor (void *const auditor, const SoNotRec::Type type)
const SoAuditorList & | getAuditors (void) const
SbBool | shouldWrite (void)
void | assertAlive (void) const

## Static Public Member Functions
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
static void | setColinearThreshold (int newval)
static int | getColinearThreshold (void)
Static Public Member Functions inherited from SoDragger
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | setMinScale (float newminscale)
static float | getMinScale (void)
static void | workValuesIntoTransform (SbMatrix &mtx, const SbVec3f *translationptr, const SbRotation *rotationptr, const SbVec3f *scalefactorptr, const SbRotation *scaleorientationptr, const SbVec3f *centerptr)
static void | getTransformFast (SbMatrix &mtx, SbVec3f &translation, SbRotation &rotation, SbVec3f &scalefactor, SbRotation &scaleorientation, const SbVec3f &center)
static void | getTransformFast (SbMatrix &mtx, SbVec3f &translation, SbRotation &rotation, SbVec3f &scalefactor, SbRotation &scaleorientation)
static SbMatrix | appendTranslation (const SbMatrix &mtx, const SbVec3f &translation, const SbMatrix *conversion=NULL)
static SbMatrix | appendScale (const SbMatrix &mtx, const SbVec3f &scale, const SbVec3f &scalecenter, const SbMatrix *conversion=NULL)
static SbMatrix | appendRotation (const SbMatrix &mtx, const SbRotation &rot, const SbVec3f &rotcenter, const SbMatrix *conversion=NULL)
static void | initClass (void)
static void | initClasses (void)
Static Public Member Functions inherited from SoInteractionKit
static SoType | getClassTypeId (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | setSwitchValue (SoNode *node, const int newVal)
Static Public Member Functions inherited from SoBaseKit
static SoType | getClassTypeId (void)
static void | initClass (void)
static const SoNodekitCatalog * | getClassNodekitCatalog (void)
static SbBool | isSearchingChildren (void)
static void | setSearchingChildren (const SbBool newval)
Static Public Member Functions inherited from SoNode
static uint32_t | getCompatibilityTypes (const SoType &nodetype)
static SoType | getClassTypeId (void)
static SoNode * | getByName (const SbName &name)
static int | getByName (const SbName &name, SoNodeList &l)
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void | initClasses (void)
static SbUniqueId | getNextNodeId (void)
static int | getActionMethodIndex (const SoType type)
static void | getBoundingBoxS (SoAction *action, SoNode *node)
static void | GLRenderS (SoAction *action, SoNode *node)
static void | callbackS (SoAction *action, SoNode *node)
static void | getMatrixS (SoAction *action, SoNode *node)
static void | handleEventS (SoAction *action, SoNode *node)
static void | pickS (SoAction *action, SoNode *node)
static void | rayPickS (SoAction *action, SoNode *node)
static void | searchS (SoAction *action, SoNode *node)
static void | writeS (SoAction *action, SoNode *node)
static void | audioRenderS (SoAction *action, SoNode *node)
static void | getPrimitiveCountS (SoAction *action, SoNode *node)
Static Public Member Functions inherited from SoFieldContainer
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | cleanupClass (void)
static void | initCopyDict (void)
static void | addCopy (const SoFieldContainer *orig, const SoFieldContainer *copy)
static SoFieldContainer * | checkCopy (const SoFieldContainer *orig)
static SoFieldContainer * | findCopy (const SoFieldContainer *orig, const SbBool copyconnections)
static void | copyDone (void)
Static Public Member Functions inherited from SoBase
static void | initClass (void)
| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static SoType | getClassTypeId (void)
| This static method returns the SoType object associated with objects of this class.
static void | addName (SoBase *const base, const char *const name)
static void | removeName (SoBase *const base, const char *const name)
static void | incrementCurrentWriteCounter (void)
static void | decrementCurrentWriteCounter (void)
static SoBase * | getNamedBase (const SbName &name, SoType type)
static int | getNamedBases (const SbName &name, SoBaseList &baselist, SoType type)
static SbBool | read (SoInput *input, SoBase *&base, SoType expectedtype)
static void | setInstancePrefix (const SbString &c)
static void | setTraceRefs (SbBool trace)
static SbBool | getTraceRefs (void)
static SbBool | connectRoute (SoInput *input, const SbName &fromnodename, const SbName &fromfieldname, const SbName &tonodename, const SbName &tofieldname)
static SbBool | readRoute (SoInput *input)

## Public Attributes
SoSFRotation | rotation
SoSFVec3f | translation
SoSFVec3f | scaleFactor
SoSFFloat | minDiscRotDot
Public Attributes inherited from SoDragger
SoSFBool | isActive
Public Attributes inherited from SoInteractionKit
SoSFEnum | renderCaching
SoSFEnum | boundingBoxCaching
SoSFEnum | renderCulling
SoSFEnum | pickCulling

## Protected Member Functions
virtual const SoFieldData * | getFieldData (void) const
virtual | ~SoTransformerDragger (void)
virtual SbBool | setUpConnections (SbBool onoff, SbBool doitalways=FALSE)
virtual void | setDefaultOnNonWritingFields (void)
void | dragStart (void)
void | drag (void)
void | dragFinish (void)
void | updateAntiSquishList (void)
void | setAllPartSwitches (int scalewhich, int rotatewhich, int translatewhich)
int | getMouseGestureDirection (SbBool x_ok, SbBool y_ok, SbBool z_ok)
Protected Member Functions inherited from SoDragger
| SoDragger (void)
virtual | ~SoDragger (void)
SbVec2f | getNormalizedLocaterPosition (void)
SbVec2s | getLocaterPosition (void)
SbVec2s | getStartLocaterPosition (void) const
void | setStartLocaterPosition (SbVec2s p)
SbBool | isAdequateConstraintMotion (void)
virtual SbBool | shouldGrabBasedOnSurrogate (const SoPath *pickpath, const SoPath *surrogatepath)
void | setCameraInfo (SoAction *action)
virtual void | handleEvent (SoHandleEventAction *ha)
void | transferMotion (SoDragger *child)
void | setIgnoreInBbox (SbBool newval)
SbBool | isIgnoreInBbox (void)
virtual void | getBoundingBox (SoGetBoundingBoxAction *action)
void | setActiveChildDragger (SoDragger *newchilddragger)
SoDragger * | getActiveChildDragger (void) const
void | updateDraggerCache (const SoPath *path)
virtual const SoPickedPoint * | getPickedPointForStart (SoHandleEventAction *action)
Protected Member Functions inherited from SoInteractionKit
virtual | ~SoInteractionKit ()
virtual void | copyContents (const SoFieldContainer *fromFC, SbBool copyConnections)
virtual SbBool | setPart (const int partNum, SoNode *node)
virtual SbBool | readInstance (SoInput *in, unsigned short flags)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, SoNode *node, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
virtual SbBool | setAnyPartAsDefault (const SbName &partname, const SbName &nodename, SbBool anypart=TRUE, SbBool onlyifdefault=TRUE)
SbBool | setAnySurrogatePath (const SbName &name, SoPath *path, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
void | connectSeparatorFields (SoSeparator *dest, SbBool onOff)
Protected Member Functions inherited from SoBaseKit
virtual | ~SoBaseKit ()
virtual SoNode * | addToCopyDict (void) const
SoGroup * | getContainerNode (const SbName &listname, SbBool makeifneeded=TRUE)
virtual SoNode * | getAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE)
virtual SoNodeKitPath * | createPathToAnyPart (const SbName &partname, SbBool makeifneeded, SbBool leafcheck=FALSE, SbBool publiccheck=FALSE, const SoPath *pathtoextend=NULL)
virtual SbBool | setAnyPart (const SbName &partname, SoNode *from, SbBool anypart=TRUE)
void | createNodekitPartsList (void)
void | createFieldList (void)
virtual void | createDefaultParts (void)
const SoNodekitParts * | getNodekitPartsList (void) const
const SbList< SoSFNode * > & | getCatalogInstances (void) const
void | catalogError (void)
void | countMyFields (SoOutput *out)
Protected Member Functions inherited from SoNode
| SoNode (void)
virtual | ~SoNode ()
Protected Member Functions inherited from SoFieldContainer
| SoFieldContainer (void)
virtual | ~SoFieldContainer ()
Protected Member Functions inherited from SoBase
| SoBase (void)
virtual | ~SoBase ()
virtual void | destroy (void)
SbBool | hasMultipleWriteRefs (void) const
SbBool | writeHeader (SoOutput *out, SbBool isgroup, SbBool isengine) const
void | writeFooter (SoOutput *out) const
virtual const char * | getFileFormatName (void) const
virtual SoNotRec | createNotRec (void)

## Static Protected Member Functions
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | startCB (void *f, SoDragger *d)
static void | motionCB (void *f, SoDragger *d)
static void | finishCB (void *f, SoDragger *d)
static void | metaKeyChangeCB (void *, SoDragger *)
static void | fieldSensorCB (void *f, SoSensor *s)
static void | valueChangedCB (void *f, SoDragger *d)
static int | getIgnoreAxis (SbVec2f axis[3][2], SbBool x_ok, SbBool y_ok, SbBool z_ok)
static void | makeMinorAxisPerpendicularIfColinear (SbVec2f origin, SbVec2f axisends[3][2], int index_a, int index_b)
static SbBool | isColinear (SbVec2f a1[2], SbVec2f a2[2], int pixels)
Static Protected Member Functions inherited from SoDragger
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | childTransferMotionAndValueChangedCB (void *, SoDragger *)
static void | childValueChangedCB (void *, SoDragger *)
static void | childStartCB (void *, SoDragger *)
static void | childMotionCB (void *, SoDragger *)
static void | childFinishCB (void *, SoDragger *)
static void | childOtherEventCB (void *, SoDragger *)
Static Protected Member Functions inherited from SoInteractionKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
static void | readDefaultParts (const char *fileName, const char defaultBuffer[], int defBufSize)
static void | fieldSensorCB (void *, SoSensor *)
Static Protected Member Functions inherited from SoBaseKit
static const SoFieldData ** | getFieldDataPtr (void)
static const SoNodekitCatalog ** | getClassNodekitCatalogPtr (void)
Static Protected Member Functions inherited from SoNode
static const SoFieldData ** | getFieldDataPtr (void)
static void | setNextActionMethodIndex (int index)
static int | getNextActionMethodIndex (void)
static void | incNextActionMethodIndex (void)
static void | setCompatibilityTypes (const SoType &nodetype, const uint32_t bitmask)
Static Protected Member Functions inherited from SoBase
static uint32_t | getCurrentWriteCounter (void)
static void | staticDataLock (void)
static void | staticDataUnlock (void)

## Protected Attributes
SoSFNode | axisFeedbackLocation
SoSFNode | axisFeedbackSep
SoSFNode | circleFeedbackAntiSquish
SoSFNode | circleFeedbackSep
SoSFNode | circleFeedbackTransform
SoSFNode | circleFeedbackTransformSwitch
SoSFNode | negXRoundWallFeedback
SoSFNode | negXWallFeedback
SoSFNode | negXWallFeedbackSwitch
SoSFNode | negYRoundWallFeedback
SoSFNode | negYWallFeedback
SoSFNode | negYWallFeedbackSwitch
SoSFNode | negZRoundWallFeedback
SoSFNode | negZWallFeedback
SoSFNode | negZWallFeedbackSwitch
SoSFNode | overallStyle
SoSFNode | posXRoundWallFeedback
SoSFNode | posXWallFeedback
SoSFNode | posXWallFeedbackSwitch
SoSFNode | posYRoundWallFeedback
SoSFNode | posYWallFeedback
SoSFNode | posYWallFeedbackSwitch
SoSFNode | posZRoundWallFeedback
SoSFNode | posZWallFeedback
SoSFNode | posZWallFeedbackSwitch
SoSFNode | radialFeedback
SoSFNode | radialFeedbackSwitch
SoSFNode | rotator1
SoSFNode | rotator1Active
SoSFNode | rotator1LocateGroup
SoSFNode | rotator1Switch
SoSFNode | rotator2
SoSFNode | rotator2Active
SoSFNode | rotator2LocateGroup
SoSFNode | rotator2Switch
SoSFNode | rotator3
SoSFNode | rotator3Active
SoSFNode | rotator3LocateGroup
SoSFNode | rotator3Switch
SoSFNode | rotator4
SoSFNode | rotator4Active
SoSFNode | rotator4LocateGroup
SoSFNode | rotator4Switch
SoSFNode | rotator5
SoSFNode | rotator5Active
SoSFNode | rotator5LocateGroup
SoSFNode | rotator5Switch
SoSFNode | rotator6
SoSFNode | rotator6Active
SoSFNode | rotator6LocateGroup
SoSFNode | rotator6Switch
SoSFNode | rotatorSep
SoSFNode | scale1
SoSFNode | scale1Active
SoSFNode | scale1LocateGroup
SoSFNode | scale1Switch
SoSFNode | scale2
SoSFNode | scale2Active
SoSFNode | scale2LocateGroup
SoSFNode | scale2Switch
SoSFNode | scale3
SoSFNode | scale3Active
SoSFNode | scale3LocateGroup
SoSFNode | scale3Switch
SoSFNode | scale4
SoSFNode | scale4Active
SoSFNode | scale4LocateGroup
SoSFNode | scale4Switch
SoSFNode | scale5
SoSFNode | scale5Active
SoSFNode | scale5LocateGroup
SoSFNode | scale5Switch
SoSFNode | scale6
SoSFNode | scale6Active
SoSFNode | scale6LocateGroup
SoSFNode | scale6Switch
SoSFNode | scale7
SoSFNode | scale7Active
SoSFNode | scale7LocateGroup
SoSFNode | scale7Switch
SoSFNode | scale8
SoSFNode | scale8Active
SoSFNode | scale8LocateGroup
SoSFNode | scale8Switch
SoSFNode | scaleBoxFeedback
SoSFNode | scaleBoxFeedbackSwitch
SoSFNode | scaleSep
SoSFNode | surroundScale
SoSFNode | translateBoxFeedback
SoSFNode | translateBoxFeedbackRotation
SoSFNode | translateBoxFeedbackSep
SoSFNode | translateBoxFeedbackSwitch
SoSFNode | translator1
SoSFNode | translator1Active
SoSFNode | translator1LocateGroup
SoSFNode | translator1Switch
SoSFNode | translator2
SoSFNode | translator2Active
SoSFNode | translator2LocateGroup
SoSFNode | translator2Switch
SoSFNode | translator3
SoSFNode | translator3Active
SoSFNode | translator3LocateGroup
SoSFNode | translator3Switch
SoSFNode | translator4
SoSFNode | translator4Active
SoSFNode | translator4LocateGroup
SoSFNode | translator4Switch
SoSFNode | translator5
SoSFNode | translator5Active
SoSFNode | translator5LocateGroup
SoSFNode | translator5Switch
SoSFNode | translator6
SoSFNode | translator6Active
SoSFNode | translator6LocateGroup
SoSFNode | translator6Switch
SoSFNode | translatorSep
SoSFNode | xAxisFeedbackActive
SoSFNode | xAxisFeedbackSelect
SoSFNode | xAxisFeedbackSwitch
SoSFNode | xCircleFeedback
SoSFNode | xCircleFeedbackSwitch
SoSFNode | xCrosshairFeedback
SoSFNode | yAxisFeedbackActive
SoSFNode | yAxisFeedbackSelect
SoSFNode | yAxisFeedbackSwitch
SoSFNode | yCircleFeedback
SoSFNode | yCircleFeedbackSwitch
SoSFNode | yCrosshairFeedback
SoSFNode | zAxisFeedbackActive
SoSFNode | zAxisFeedbackSelect
SoSFNode | zAxisFeedbackSwitch
SoSFNode | zCircleFeedback
SoSFNode | zCircleFeedbackSwitch
SoSFNode | zCrosshairFeedback
SoFieldSensor * | translFieldSensor
SoFieldSensor * | scaleFieldSensor
SoFieldSensor * | rotateFieldSensor
SoNodeList | antiSquishList
Protected Attributes inherited from SoDragger
SoSFNode | motionMatrix
Protected Attributes inherited from SoInteractionKit
SoSFNode | geomSeparator
SoSFNode | topSeparator
SoFieldSensor * | fieldSensor
SoSeparator * | oldTopSep
Protected Attributes inherited from SoBaseKit
SoSFNode | callbackList
SoChildList * | children
SbBool | connectionsSetUp
Protected Attributes inherited from SoNode
SbUniqueId | uniqueId
Protected Attributes inherited from SoFieldContainer
SbBool | isBuiltIn

## Additional Inherited Members
Protected Types inherited from SoBase
enum | BaseFlags { IS_ENGINE = 0x01 , IS_GROUP = 0x02 }
Static Protected Attributes inherited from SoNode
static SbUniqueId | nextUniqueId = 1
static int | nextActionMethodIndex = 0

## Detailed Description

The SoTransformerDragger provides geometry for translation, scaling and rotations.

Here's how the dragger looks with its default geometry in the inactive state:

Screen Shot of Default Dragger

Translate the dragger by clicking and dragging any of the (invisible) sides. Translation will default be done in the plane of the side the end-user selected. The user can hold down a `SHIFT` key to lock translation to a single of the axes in the plane. By holding down a `CTRL` key instead, translation can be done along the plane's normal vector.

Scaling is done by dragging the corner cubes. By default, uniform scaling will be done. Hold down `SHIFT` before selecting any of the corners to do non-uniform scaling. Uniform scaling towards a corner-point can be accomplished by holding down `CTRL` before clicking and dragging one of the cubes.

Rotation is done by dragging any of the 6 end-markers of the axis cross. The initial drag direction decides which orientation the rotation will be done in. Hold down `SHIFT` to do free-form rotation around the sphere instead.

This is a big and complex dragger which needs a fair amount of proper documentation when provided in end-user applications. If what you are trying to accomplish in your application does not really demand most of the features of this dragger, you are advised to investigate whether or not any of the less complex draggers can fulfill your requirements – so you can provide an as simple as possible user interface to your end-users.

For the application programmer's convenience, the Coin library also provides a manipulator class called SoTransformerManip, which wraps the SoTransformerDragger into the necessary mechanisms for making direct insertion of this dragger into a scene graph possible with very little effort.

See also
  SoTransformerManip

## Member Enumeration Documentation

## ◆ State

enum SoTransformerDragger::State

The various possible states the dragger might be in at any given time. That is: either SoTransformerDragger::INACTIVE if there's no interaction, or any of the other values to indicate what operation the end-user is currently executing.

## Constructor & Destructor Documentation

## ◆ SoTransformerDragger()

SoTransformerDragger::SoTransformerDragger | ( | void |  | ) |

Default constructor, sets up the dragger nodekit catalog with the interaction and feedback geometry.

Nodekit structure (new entries versus parent class marked with arrow prefix):

    CLASS SoTransformerDragger
    -->"this"
          "callbackList"
          "topSeparator"
             "motionMatrix"
    -->      "surroundScale"
    -->      "overallStyle"
             "geomSeparator"
    -->         "axisFeedbackSep"
    -->            "axisFeedbackLocation"
    -->            "xAxisFeedbackSwitch"
    -->               "xAxisFeedbackActive"
    -->               "xAxisFeedbackSelect"
    -->               "xCrosshairFeedback"
    -->            "yAxisFeedbackSwitch"
    -->               "yAxisFeedbackActive"
    -->               "yAxisFeedbackSelect"
    -->               "yCrosshairFeedback"
    -->            "zAxisFeedbackSwitch"
    -->               "zAxisFeedbackActive"
    -->               "zAxisFeedbackSelect"
    -->               "zCrosshairFeedback"
    -->         "translateBoxFeedbackSep"
    -->            "translateBoxFeedbackSwitch"
    -->               "translateBoxFeedbackRotation"
    -->               "translateBoxFeedback"
    -->         "scaleBoxFeedbackSwitch"
    -->            "scaleBoxFeedback"
    -->         "posXWallFeedbackSwitch"
    -->            "posXWallFeedback"
    -->            "posXRoundWallFeedback"
    -->         "posYWallFeedbackSwitch"
    -->            "posYWallFeedback"
    -->            "posYRoundWallFeedback"
    -->         "posZWallFeedbackSwitch"
    -->            "posZWallFeedback"
    -->            "posZRoundWallFeedback"
    -->         "negXWallFeedbackSwitch"
    -->            "negXWallFeedback"
    -->            "negXRoundWallFeedback"
    -->         "negYWallFeedbackSwitch"
    -->            "negYWallFeedback"
    -->            "negYRoundWallFeedback"
    -->         "negZWallFeedbackSwitch"
    -->            "negZWallFeedback"
    -->            "negZRoundWallFeedback"
    -->         "radialFeedbackSwitch"
    -->            "radialFeedback"
    -->      "translatorSep"
    -->         "translator1Switch"
    -->            "translator1LocateGroup"
    -->               "translator1"
    -->            "translator1Active"
    -->         "translator2Switch"
    -->            "translator2LocateGroup"
    -->               "translator2"
    -->            "translator2Active"
    -->         "translator3Switch"
    -->            "translator3LocateGroup"
    -->               "translator3"
    -->            "translator3Active"
    -->         "translator4Switch"
    -->            "translator4LocateGroup"
    -->               "translator4"
    -->            "translator4Active"
    -->         "translator5Switch"
    -->            "translator5LocateGroup"
    -->               "translator5"
    -->            "translator5Active"
    -->         "translator6Switch"
    -->            "translator6LocateGroup"
    -->               "translator6"
    -->            "translator6Active"
    -->      "rotatorSep"
    -->         "rotator1Switch"
    -->            "rotator1LocateGroup"
    -->               "rotator1"
    -->            "rotator1Active"
    -->         "rotator2Switch"
    -->            "rotator2LocateGroup"
    -->               "rotator2"
    -->            "rotator2Active"
    -->         "rotator3Switch"
    -->            "rotator3LocateGroup"
    -->               "rotator3"
    -->            "rotator3Active"
    -->         "rotator4Switch"
    -->            "rotator4LocateGroup"
    -->               "rotator4"
    -->            "rotator4Active"
    -->         "rotator5Switch"
    -->            "rotator5LocateGroup"
    -->               "rotator5"
    -->            "rotator5Active"
    -->         "rotator6Switch"
    -->            "rotator6LocateGroup"
    -->               "rotator6"
    -->            "rotator6Active"
    -->      "scaleSep"
    -->         "scale1Switch"
    -->            "scale1LocateGroup"
    -->               "scale1"
    -->            "scale1Active"
    -->         "scale2Switch"
    -->            "scale2LocateGroup"
    -->               "scale2"
    -->            "scale2Active"
    -->         "scale3Switch"
    -->            "scale3LocateGroup"
    -->               "scale3"
    -->            "scale3Active"
    -->         "scale4Switch"
    -->            "scale4LocateGroup"
    -->               "scale4"
    -->            "scale4Active"
    -->         "scale5Switch"
    -->            "scale5LocateGroup"
    -->               "scale5"
    -->            "scale5Active"
    -->         "scale6Switch"
    -->            "scale6LocateGroup"
    -->               "scale6"
    -->            "scale6Active"
    -->         "scale7Switch"
    -->            "scale7LocateGroup"
    -->               "scale7"
    -->            "scale7Active"
    -->         "scale8Switch"
    -->            "scale8LocateGroup"
    -->               "scale8"
    -->            "scale8Active"
    -->      "circleFeedbackSep"
    -->         "circleFeedbackTransformSwitch"
    -->            "circleFeedbackAntiSquish"
    -->            "circleFeedbackTransform"
    -->         "xCircleFeedbackSwitch"
    -->            "xCircleFeedback"
    -->         "yCircleFeedbackSwitch"
    -->            "yCircleFeedback"
    -->         "zCircleFeedbackSwitch"
    -->            "zCircleFeedback"

(See SoBaseKit::printDiagram() for information about the output formatting.)

Detailed information on catalog parts:

    CLASS SoTransformerDragger
    PVT   "this",  SoTransformerDragger  ---
          "callbackList",  SoNodeKitListPart [ SoCallback, SoEventCallback ]
    PVT   "topSeparator",  SoSeparator  ---
    PVT   "motionMatrix",  SoMatrixTransform  ---
          "surroundScale",  SoSurroundScale  ---
    PVT   "overallStyle",  SoGroup  ---
    PVT   "geomSeparator",  SoSeparator  ---
    PVT   "translatorSep",  SoSeparator  ---
    PVT   "translator1Switch",  SoSwitch  ---
    PVT   "translator1LocateGroup",  SoLocateHighlight  ---
          "translator1",  SoSeparator  ---
          "translator1Active",  SoSeparator  ---
    PVT   "translator2Switch",  SoSwitch  ---
    PVT   "translator2LocateGroup",  SoLocateHighlight  ---
          "translator2",  SoSeparator  ---
          "translator2Active",  SoSeparator  ---
    PVT   "translator3Switch",  SoSwitch  ---
    PVT   "translator3LocateGroup",  SoLocateHighlight  ---
          "translator3",  SoSeparator  ---
          "translator3Active",  SoSeparator  ---
    PVT   "translator4Switch",  SoSwitch  ---
    PVT   "translator4LocateGroup",  SoLocateHighlight  ---
          "translator4",  SoSeparator  ---
          "translator4Active",  SoSeparator  ---
    PVT   "translator5Switch",  SoSwitch  ---
    PVT   "translator5LocateGroup",  SoLocateHighlight  ---
          "translator5",  SoSeparator  ---
          "translator5Active",  SoSeparator  ---
    PVT   "translator6Switch",  SoSwitch  ---
    PVT   "translator6LocateGroup",  SoLocateHighlight  ---
          "translator6",  SoSeparator  ---
          "translator6Active",  SoSeparator  ---
    PVT   "rotatorSep",  SoSeparator  ---
    PVT   "rotator1Switch",  SoSwitch  ---
    PVT   "rotator1LocateGroup",  SoLocateHighlight  ---
          "rotator1",  SoSeparator  ---
          "rotator1Active",  SoSeparator  ---
    PVT   "rotator2Switch",  SoSwitch  ---
    PVT   "rotator2LocateGroup",  SoLocateHighlight  ---
          "rotator2",  SoSeparator  ---
          "rotator2Active",  SoSeparator  ---
    PVT   "rotator3Switch",  SoSwitch  ---
    PVT   "rotator3LocateGroup",  SoLocateHighlight  ---
          "rotator3",  SoSeparator  ---
          "rotator3Active",  SoSeparator  ---
    PVT   "rotator4Switch",  SoSwitch  ---
    PVT   "rotator4LocateGroup",  SoLocateHighlight  ---
          "rotator4",  SoSeparator  ---
          "rotator4Active",  SoSeparator  ---
    PVT   "rotator5Switch",  SoSwitch  ---
    PVT   "rotator5LocateGroup",  SoLocateHighlight  ---
          "rotator5",  SoSeparator  ---
          "rotator5Active",  SoSeparator  ---
    PVT   "rotator6Switch",  SoSwitch  ---
    PVT   "rotator6LocateGroup",  SoLocateHighlight  ---
          "rotator6",  SoSeparator  ---
          "rotator6Active",  SoSeparator  ---
    PVT   "scaleSep",  SoSeparator  ---
    PVT   "scale1Switch",  SoSwitch  ---
    PVT   "scale1LocateGroup",  SoLocateHighlight  ---
          "scale1",  SoSeparator  ---
          "scale1Active",  SoSeparator  ---
    PVT   "scale2Switch",  SoSwitch  ---
    PVT   "scale2LocateGroup",  SoLocateHighlight  ---
          "scale2",  SoSeparator  ---
          "scale2Active",  SoSeparator  ---
    PVT   "scale3Switch",  SoSwitch  ---
    PVT   "scale3LocateGroup",  SoLocateHighlight  ---
          "scale3",  SoSeparator  ---
          "scale3Active",  SoSeparator  ---
    PVT   "scale4Switch",  SoSwitch  ---
    PVT   "scale4LocateGroup",  SoLocateHighlight  ---
          "scale4",  SoSeparator  ---
          "scale4Active",  SoSeparator  ---
    PVT   "scale5Switch",  SoSwitch  ---
    PVT   "scale5LocateGroup",  SoLocateHighlight  ---
          "scale5",  SoSeparator  ---
          "scale5Active",  SoSeparator  ---
    PVT   "scale6Switch",  SoSwitch  ---
    PVT   "scale6LocateGroup",  SoLocateHighlight  ---
          "scale6",  SoSeparator  ---
          "scale6Active",  SoSeparator  ---
    PVT   "scale7Switch",  SoSwitch  ---
    PVT   "scale7LocateGroup",  SoLocateHighlight  ---
          "scale7",  SoSeparator  ---
          "scale7Active",  SoSeparator  ---
    PVT   "scale8Switch",  SoSwitch  ---
    PVT   "scale8LocateGroup",  SoLocateHighlight  ---
          "scale8",  SoSeparator  ---
          "scale8Active",  SoSeparator  ---
    PVT   "circleFeedbackSep",  SoSeparator  ---
    PVT   "circleFeedbackTransformSwitch",  SoSwitch  ---
    PVT   "circleFeedbackAntiSquish",  SoAntiSquish  ---
    PVT   "circleFeedbackTransform",  SoTransform  ---
    PVT   "xCircleFeedbackSwitch",  SoSwitch  ---
          "xCircleFeedback",  SoSeparator  ---
    PVT   "yCircleFeedbackSwitch",  SoSwitch  ---
          "yCircleFeedback",  SoSeparator  ---
    PVT   "zCircleFeedbackSwitch",  SoSwitch  ---
          "zCircleFeedback",  SoSeparator  ---
    PVT   "axisFeedbackSep",  SoSeparator  ---
    PVT   "axisFeedbackLocation",  SoTranslation  ---
    PVT   "xAxisFeedbackSwitch",  SoSwitch  ---
          "xAxisFeedbackActive",  SoSeparator  ---
          "xAxisFeedbackSelect",  SoSeparator  ---
          "xCrosshairFeedback",  SoSeparator  ---
    PVT   "yAxisFeedbackSwitch",  SoSwitch  ---
          "yAxisFeedbackActive",  SoSeparator  ---
          "yAxisFeedbackSelect",  SoSeparator  ---
          "yCrosshairFeedback",  SoSeparator  ---
    PVT   "zAxisFeedbackSwitch",  SoSwitch  ---
          "zAxisFeedbackActive",  SoSeparator  ---
          "zAxisFeedbackSelect",  SoSeparator  ---
          "zCrosshairFeedback",  SoSeparator  ---
    PVT   "translateBoxFeedbackSep",  SoSeparator  ---
    PVT   "translateBoxFeedbackSwitch",  SoSwitch  ---
    PVT   "translateBoxFeedbackRotation",  SoRotation  ---
          "translateBoxFeedback",  SoSeparator  ---
    PVT   "scaleBoxFeedbackSwitch",  SoSwitch  ---
          "scaleBoxFeedback",  SoSeparator  ---
    PVT   "posXWallFeedbackSwitch",  SoSwitch  ---
          "posXWallFeedback",  SoSeparator  ---
          "posXRoundWallFeedback",  SoSeparator  ---
    PVT   "posYWallFeedbackSwitch",  SoSwitch  ---
          "posYWallFeedback",  SoSeparator  ---
          "posYRoundWallFeedback",  SoSeparator  ---
    PVT   "posZWallFeedbackSwitch",  SoSwitch  ---
          "posZWallFeedback",  SoSeparator  ---
          "posZRoundWallFeedback",  SoSeparator  ---
    PVT   "negXWallFeedbackSwitch",  SoSwitch  ---
          "negXWallFeedback",  SoSeparator  ---
          "negXRoundWallFeedback",  SoSeparator  ---
    PVT   "negYWallFeedbackSwitch",  SoSwitch  ---
          "negYWallFeedback",  SoSeparator  ---
          "negYRoundWallFeedback",  SoSeparator  ---
    PVT   "negZWallFeedbackSwitch",  SoSwitch  ---
          "negZWallFeedback",  SoSeparator  ---
          "negZRoundWallFeedback",  SoSeparator  ---
    PVT   "radialFeedbackSwitch",  SoSwitch  ---
          "radialFeedback",  SoSeparator  ---

(See SoBaseKit::printTable() for information about the output formatting.)

## ◆ ~SoTransformerDragger()

SoTransformerDragger::~SoTransformerDragger | ( | void |  | ) |
| protectedvirtual

Protected destructor.

(Dragger classes are derived from SoBase, so they are reference counted and automatically destroyed when their reference count goes to 0.)

## Member Function Documentation

## ◆ getClassTypeId()

SoType SoTransformerDragger::getClassTypeId | ( | void |  | ) |
| static

This static method returns the SoType object associated with objects of this class.

## ◆ getTypeId()

SoType SoTransformerDragger::getTypeId | ( | void |  | ) | const
| virtual

Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and "downward" casting.

Reimplemented from SoDragger.

## ◆ getFieldDataPtr()

const SoFieldData ** SoTransformerDragger::getFieldDataPtr | ( | void |  | ) |
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Returns the SoFieldData class which holds information about fields in this node.

## ◆ getFieldData()

const SoFieldData * SoTransformerDragger::getFieldData | ( | void |  | ) | const
| protectedvirtual

Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns `NULL`.

Reimplemented from SoDragger.

## ◆ getClassNodekitCatalog()

const SoNodekitCatalog * SoTransformerDragger::getClassNodekitCatalog | ( | void |  | ) |
| static

Returns the nodekit catalog which defines the layout of this class' kit.

## ◆ getNodekitCatalog()

const SoNodekitCatalog * SoTransformerDragger::getNodekitCatalog | ( | void |  | ) | const
| virtual

Returns the nodekit catalog which defines the layout of this class' kit.

Reimplemented from SoDragger.

## ◆ getClassNodekitCatalogPtr()

const SoNodekitCatalog ** SoTransformerDragger::getClassNodekitCatalogPtr | ( | void |  | ) |
| staticprotected

Returns the pointer to the pointer of the nodekit catalog for this class.

## ◆ initClass()

void SoTransformerDragger::initClass | ( | void |  | ) |
| static

Initializes type system for this dragger class.

Application programmers should usually not have to invoke this method, see documentation of SoInteraction::init().

## ◆ getCurrentState()

SoTransformerDragger::State SoTransformerDragger::getCurrentState | ( | void |  | ) |

Returns an indicator for the current operation executed on the dragger by the end-user – or SoTransformerDragger::INACTIVE if none.

## ◆ setUpConnections()

SbBool SoTransformerDragger::setUpConnections | ( | SbBool | onoff,
|  | SbBool | doitalways = FALSE )
| protectedvirtual

Sets up all internal connections for instances of this class.

(This method will usually not be of interest to the application programmer, unless you want to extend the library with new custom nodekits or dragger classes. If so, see the SoBaseKit class documentation.)

Reimplemented from SoInteractionKit.

## ◆ setDefaultOnNonWritingFields()

void SoTransformerDragger::setDefaultOnNonWritingFields | ( | void |  | ) |
| protectedvirtual

(Be aware that this method is unlikely to be of interest to the application programmer who does not want to extend the library with new custom nodekits or draggers. If you indeed are writing extensions, see the information in the SoBaseKit class documentation.)

This is a virtual method, and the code in it should call SoField::setDefault() with argument `TRUE` on part fields that should not be written upon scene graph export operations.

This is typically done when:

1. field value is `NULL` and part is `NULL` by default

2. it is a leaf SoGroup or SoSeparator node with no children

3. it is a leaf listpart with no children and an SoGroup or SoSeparator container

4. it is a non-leaf part and it is of SoGroup type and all fields are at their default values

Subclasses should usually override this to do additional settings for new member fields. From the subclass, do remember to call "upwards" to your superclass' setDefaultOnNonWritingFields() method.

Reimplemented from SoDragger.

## ◆ startCB()

void SoTransformerDragger::startCB | ( | void * | f,
|  | SoDragger * | d )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ motionCB()

void SoTransformerDragger::motionCB | ( | void * | f,
|  | SoDragger * | d )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ finishCB()

void SoTransformerDragger::finishCB | ( | void * | f,
|  | SoDragger * | d )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ metaKeyChangeCB()

void SoTransformerDragger::metaKeyChangeCB | ( | void * | ,
|  | SoDragger * | d )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ fieldSensorCB()

void SoTransformerDragger::fieldSensorCB | ( | void * | d,
|  | SoSensor * | s )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ valueChangedCB()

void SoTransformerDragger::valueChangedCB | ( | void * | f,
|  | SoDragger * | d )
| staticprotected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ dragStart()

void SoTransformerDragger::dragStart | ( | void |  | ) |
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when dragger is selected (picked) by the user.

## ◆ drag()

void SoTransformerDragger::drag | ( | void |  | ) |
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when user drags the mouse after picking the dragger.

## ◆ dragFinish()

void SoTransformerDragger::dragFinish | ( | void |  | ) |
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
Called when mouse button is released after picking and interacting with the dragger.

## ◆ getMouseGestureDirection()

int SoTransformerDragger::getMouseGestureDirection | ( | SbBool | x_ok,
|  | SbBool | y_ok,
|  | SbBool | z_ok )
| protected

Not implemented in Coin; should probably not have been public in the Open Inventor API. We'll consider to implement it if requested.

## ◆ getIgnoreAxis()

int SoTransformerDragger::getIgnoreAxis | ( | SbVec2f | axis[3][2],
|  | SbBool | x_ok,
|  | SbBool | y_ok,
|  | SbBool | z_ok )
| staticprotected

Not implemented in Coin; should probably not have been public in the Open Inventor API. We'll consider to implement it if requested.

## ◆ makeMinorAxisPerpendicularIfColinear()

void SoTransformerDragger::makeMinorAxisPerpendicularIfColinear | ( | SbVec2f | origin,
|  | SbVec2f | axisends[3][2],
|  | int | index_a,
|  | int | index_b )
| staticprotected

Not implemented in Coin; should probably not have been public in the Open Inventor API. We'll consider to implement it if requested.

## ◆ isColinear()

SbBool SoTransformerDragger::isColinear | ( | SbVec2f | a1[2],
|  | SbVec2f | a2[2],
|  | int | pixels )
| staticprotected

Not implemented in Coin; should probably not have been public in the Open Inventor API. We'll consider to implement it if requested.

## Member Data Documentation

## ◆ rotation

SoSFRotation SoTransformerDragger::rotation

This field is continuously updated to contain the orientation of the dragger.

## ◆ translation

SoSFVec3f SoTransformerDragger::translation

The dragger's offset position from the local origo.

## ◆ scaleFactor

SoSFVec3f SoTransformerDragger::scaleFactor

Continuously updated to contain the current vector of scaling along the X, Y and Z axes.

## ◆ translFieldSensor

SoFieldSensor* SoTransformerDragger::translFieldSensor
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ scaleFieldSensor

SoFieldSensor* SoTransformerDragger::scaleFieldSensor
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ rotateFieldSensor

SoFieldSensor* SoTransformerDragger::rotateFieldSensor
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

## ◆ antiSquishList

SoNodeList SoTransformerDragger::antiSquishList
| protected

This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

The documentation for this class was generated from the following files:

- SoTransformerDragger.h
- SoTransformerDragger.cpp